<?php
/**
 * Plugin forceArtPos
 * @author	Suricat
 **/
class forceArtPos extends plxPlugin {

	/**
	 * Constructeur de la classe
	 *
	 * @param	default_lang	langue par défaut
	 * @return	stdio
	 * @author	Suricat
	 **/
	public function __construct($default_lang) {

        # appel du constructeur de la classe plxPlugin (obligatoire)
        parent::__construct($default_lang);

        # déclaration des hooks
		$this->addHook('AdminArticleInitData'  , 'AdminArticleInitData'  );
		$this->addHook('AdminArticleParseData' , 'AdminArticleParseData' );
		$this->addHook('AdminArticleSidebar'   , 'AdminArticleSidebar'   );
		$this->addHook('plxAdminEditArticle'   , 'plxAdminEditArticle'   );
		$this->addHook('plxMotorDemarrageEnd'  , 'plxMotorDemarrageEnd'  );
		
        # Autorisation d'acces à la configuration du plugins
		$this-> setConfigProfil(PROFIL_ADMIN);
	}
	
	
	//---------------------------------------------------------------------------------------
	//--- Initialisation de la variable utilisée dans la création/modification d'un article -
	//---------------------------------------------------------------------------------------
	public function AdminArticleInitData () {
		echo '<?php $force_art_pos = ""; ?>';
	}
	
	
	//---------------------------------------------------------------------------------------
	//--- Récupération de la position de l'article édité depuis la configuration du plugin --
	//---------------------------------------------------------------------------------------
	public function AdminArticleParseData () {
	    echo "<?php 
		        // Récupère la chaine JSON stockant les associations position-article dans la configuration du plugin
				// Format de la chaine JSON : {NumPosition:NumArticle,...} 
				// Exemple : {'1':'0022','8':'0016'} => Article 22 sera mis en position 1 et Article 16 sera mis en position 8
		        \$StrOPosArt = plxUtils::cdataCheck(trim(\$plxAdmin->plxPlugins->aPlugins['forceArtPos']->getParam('OPosArt')));
				if(isset(\$StrOPosArt) && strlen(\$StrOPosArt)>2)
					{
					  // Décodage de la chaine JSON pour en faire un tableau d'association PHP
					  \$OPosArt = json_decode(\$StrOPosArt, true);
					  
					  // On parcourt l'objet OPosArt
					  foreach (\$OPosArt as \$k=> \$v) 
						  {
						    // Si le numéro de l'article en cours d'édition est dans OPosArt, alors on récupère sa position
							if(\$result['numero']==\$v)
							  {
							    \$force_art_pos = \$k;
								break;
							  }
						  }
				    }
			 ?>";
	}
	
	
	//---------------------------------------------------------------------------------------
	//--- Ajout de la liste déroulante affichant les positions possibles de l'article -------
	//--- Si une position a été indiquée pour l'article, celle-ci est "selected" ------------
	//---------------------------------------------------------------------------------------
	public function AdminArticleSidebar(){
		echo <<<END
		     <p><label for="id_force_art_pos">{$this->getlang('L_LIBELLE')}&nbsp;:</label>
			 <select id="id_force_art_pos" name="force_art_pos" style="width:50px">
			 <?php
			    \$i;
		        \$NbPos=11;
				for(\$i=0; \$i<=\$NbPos; \$i++)
					{
					  echo('<option value="'.\$i.'" ');
					  if(\$force_art_pos==\$i) { echo('selected="selected"'); }
					  echo('>'.((\$i==0) ? '' : \$i).'</option>');
					} 
			 ?>	  
		     </select>
END;
    }
	
	
	//---------------------------------------------------------------------------------------
	//--- Enregistrement du tableau d'association Position-Article dans la configuration ----
    //--- du plugin au moment de l'enregistrement de l'article ------------------------------
	//---------------------------------------------------------------------------------------
	public function plxAdminEditArticle(){
		echo "<?php 
		        \$OPosArt = array();
				// Récupère dans 'fap' la position de l'article indiquée dans la SideBar
				\$fap = intval(plxUtils::cdataCheck(trim(\$content['force_art_pos'])));
				// Récupère la chaine JSON stockant les associations position-article dans la configuration du plugin
		        \$StrOPosArt = plxUtils::cdataCheck(trim(\$this->plxPlugins->aPlugins['forceArtPos']->getParam('OPosArt')));
				if(isset(\$StrOPosArt) && strlen(\$StrOPosArt)>2)
					{
					  \$OPosArt = json_decode(\$StrOPosArt, true);
					  
					  foreach (\$OPosArt as \$k=> \$v) 
						  {
						    // si rien n'a changé (la position de l'article est déjà indiquée dans OPosArt
							if(\$id==\$v && intval(\$k)==\$fap)
							  {
							    break;
							  }
							// si la position est renseignée avec un autre id, on écrase avec le nouvel id
							if(intval(\$k)==\$fap)
							  {
							    \$OPosArt[\$k]=\$id;
							  }
							else // si l'id était renseigné à une autre position, on supprime la référence à cette ancienne position
							if(\$id==\$v)
							  {
							    unset(\$OPosArt[\$k]);
							  }
						  }
				    }
						  
			    // Si la position n'est pas renseignée dans OPosArt, on la crée
			    if(!isset(\$OPosArt[\$fap]) && \$fap!=0)
				    {
					  \$OPosArt[\$fap]=\$id;
				    }

				// enregistrement de OPosArt au format JSON dans la configuration du plugin
				\$this->plxPlugins->aPlugins['forceArtPos']->setParam('OPosArt', json_encode(\$OPosArt), 'cdata');  \$this->plxPlugins->aPlugins['forceArtPos']->saveParams(); 
			 ?>";
	}
	
	
	//---------------------------------------------------------------------------------------
	//--- Change le positionnement des articles de la page 1 de la Home selon les -----------
	//--- associations Position-article indiquées dans la configuration du plugin -----------
	//---------------------------------------------------------------------------------------
	public function plxMotorDemarrageEnd () {
	    $plxMotor_inst = plxMotor::getInstance();
		// si on est sur la page 1 de la Home
		if($plxMotor_inst->mode == 'home' && $plxMotor_inst->page==1) 
		    {
			  // Récupère la chaine JSON stockant les associations position-article dans la configuration du plugin
			  $StrOPosArt = plxUtils::cdataCheck(trim($this->getParam('OPosArt')));
			  if(isset($StrOPosArt) && strlen($StrOPosArt)>2)
				  {
				    $OPosArt = json_decode($StrOPosArt, true);
					// Récupération du tableau d'objets représentant les articles listés dans la Home
				    $TOArticle = $plxMotor_inst->plxRecord_arts->result;
				    $NbArt = $plxMotor_inst->plxRecord_arts->size;
					
					// met dans TOrderNumArt les numéros des articles de la Home
					$TOrderNumArt = array();
					for($i=0; $i<$NbArt; $i++) 
					    {
						  array_push($TOrderNumArt, $TOArticle[$i]['numero']);
						}
						
					// ajoute à la fin de $TOArticle les articles dont le numéro est listé dans OPosArt 
					// mais qui ne sont pas présents dans TOrderNumArt
					foreach ($OPosArt as $k=> $v) 
						{
						  if(!in_array($v, $TOrderNumArt))
						      {
							    $a = $plxMotor_inst->plxGlob_arts->query('/^'.$v.'.(.*).xml$/');
							    array_push($TOArticle, $plxMotor_inst->parseArticle(PLX_ROOT.$plxMotor_inst->aConf['racine_articles'].$a['0']));	
								$NbArt++;
							  }
						}
					$plxMotor_inst->plxRecord_arts->size = $NbArt;
					
					// Réordonne TOArticle pour mettre les articles à la bonne position
				    for($i=0; $i<$NbArt; $i++) 
					    {
						  if(!isset($OPosArt["".($i+1)])) continue;
						  $NumArt = $OPosArt["".($i+1)];
						  
						  for($j=0; $j<$NbArt; $j++) 
					          {
							    if($TOArticle[$j]['numero']==$NumArt)
								    {
									  if($j != $i)
										  {
											$tmp = array_splice($TOArticle, $j, 1);
					                        array_splice($TOArticle, $i, 0, $tmp);
										  }
									}
							  }
						}
						
				    // Remplace le tableau des articles par le nouveau tableau réordonné
					$plxMotor_inst->plxRecord_arts->result = $TOArticle;
			      }
			}
	}
}
?>